# Extend an ants wick indefinitely to show the development
# of a lightspeed fuse with quadratically growing population.
# This version extends the ants fuse one tick at a time
# Author: Dave Greene, 13 March 2007

import golly as g
from glife import *
from time import sleep

rule ()  # Life

ants = pattern("2b2o$2o$2o$2b2o!")

fuse = pattern()

for fuse_end in range (0, 32):
  fuse += ants(5 * fuse_end, 0)
fuse_end=-1

fuse.display("quadfuse")
g.setcell(158,0,0)

g.fit()
g.show("Press +, -, *, /, or f to control the pattern, or ESC to exit.")

# annoying melodramatic pause
g.update()
sleep(1)

# now start running the timer
ticks=0
fuse_step=1
fuse_target=0
display_step=1
display_target=0

while True:
  ch = g.getkey()
  if len(ch) > 0:
    if ch=="+" or ch=="=": # override defaults here to get smaller step size
      display_step *= 2
    elif ch=="-" or ch=="_":
      if display_step != 1:
        display_step /= 2
    else:
    # elif ch=="*" or ch=="/" or ch=="f":
      g.dokey(ch) # just pass these keys through and let Golly handle them
  g.run(1)
  g.setcell(fuse_end,1,1)
  g.setcell(fuse_end,2,1)
  fuse_end-=1
  
  if ticks==display_target:
    g.update()
    display_target+=display_step
  ticks+=1
g.show("") # clear the script message before exiting