# Extend an ants wick indefinitely to show the development
# of a lightspeed fuse with quadratically growing population
# The wick is lengthened whenever it runs out, every 512 ticks.
# Author: Dave Greene, 13 March 2007

import golly as g
from glife import *
from time import sleep

g.setrule("b3/s23")   # Life

ants = pattern("2b2o$2o$2o$2b2o!")

fuse = pattern()

for fuse_end in range (0, 205):
   fuse += ants(5 * fuse_end, 0)


g.new("Quadratic 'ants' fuse")
g.show("Press +, -, *, /, or f to control the pattern, or ESC to exit.")

ticks=0
fuse_step=1
fuse_target=0
display_step=1
display_target=0
fuse_extend_target=0
fuse_end=-1
increase_display_step=0

while True:
   ch = g.getkey()
   if len(ch) > 0:
      if ch=="+" or ch=="=": # override defaults here to get smaller step size
         if display_step<512:
            increase_display_step=1
      elif ch=="-" or ch=="_":
         if display_step != 1:
            display_step /= 2
      else:
         g.dokey(ch) # handles *, /, f, arrow keys, etc.
   
   # weird detail:  can only increase step size
   if increase_display_step==1 and ticks % (display_step*2) == 0:
      display_step *= 2
      increase_display_step=0

   if ticks==fuse_extend_target:
      fuse_extend_target+=512 # must be of the form 5n+2 to work
      fuse_end-=512
      g.putcells(fuse,fuse_end, 0, 1, 0, 0, 1)
      g.setcell(fuse_end,1,0)
      g.setcell(fuse_end,2,0)
      if ticks==0:
         # a few corrections to make when first starting --
         g.setcell(510,0,0)
         g.setcell(450,-30,1)
         g.setcell(451,-30,1)
         g.setcell(450,-31,1) # block the escape of two gliders
         g.setcell(300,-100,1)
         g.setcell(301,-100,1)
         g.setcell(300,-101,1)
         g.fit()
         g.setmag( g.getmag() - 2 )
         g.update()
         sleep(1) # annoying melodramatic pause
      else:
         # fix the not-quite-correct overlap with the next 'ants' segment
         g.setcell(fuse_end+1025-1,-1,1)
         g.setcell(fuse_end+1025-2,1,0)
         g.setcell(fuse_end+1025-2,2,0)
         g.setcell(fuse_end+1025-1,4,1)
      
   g.run(display_step)
   if ticks==display_target:
      g.update()
      display_target+=display_step
   ticks+=display_step
g.show("") # clear the script message before exiting
